
var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

function Debug(o){
	lInfo.logln(o);
}


function prepareCurve(oDevice,curve_id,fLZ) {
	var deviceProductID=oDevice.productID;
	var deviceFirmwareID=oDevice.revisionID;

	if (curve_id<0) {
		return doCalcCurve(Math.abs(curve_id),[], 0, deviceProductID, deviceFirmwareID,false, 0);
	} 
	var sResult = Property.getNode('dbcache').getValue();	
	sResult = sResult.replace(/&amp;/g, '&').replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&#039;/g, '\'');
	var oCatalog=JSON.parse(sResult);
	var dimmbar_ab=-1;
	var curve=[];
	var AnAb=0;
	lInfo.logln('suche Kurve '+curve_id);
	for (var iIndex=0;iIndex<oCatalog.illuminant.length;iIndex++)
		for (var jIndex=0;jIndex<oCatalog.illuminant[iIndex].curves.length;jIndex++) {
			var oItem=oCatalog.illuminant[iIndex].curves[jIndex];
			lInfo.logln('suche Kurve '+curve_id + ' = ' + oItem.id);
			if (oItem.id==curve_id) {
				lInfo.logln('kurve gefunden');
				dimmbar_ab=oItem.dimmMin;
				AnAb=oItem.dimmType;
				for (var kIndex=0;kIndex<oItem.values.length;kIndex++) {
					curve.push({pos:oItem.values[kIndex].pos, value:oItem.values[kIndex].val});
				}
				curve.sort(function(a,b){return a.pos-b.pos;});
			}
		} 
	
	if (dimmbar_ab==-1) {
		return false;
	} else {		 
		if (AnAb>1)
			return doCalcCurve(1, curve, dimmbar_ab, deviceProductID, deviceFirmwareID,fLZ, AnAb&0x1);
		else
			return doCalcCurve(0, curve, dimmbar_ab, deviceProductID, deviceFirmwareID,fLZ, AnAb&0x1);		
	}
}

function executeProgramm(dsid,id) {
	lInfo.logln('starteProgrammierung fr ' + dsid + ' mit ' +id);
	 try {
	    var oDevice=getDevices().byDSID(dsid); //throws exception if device with dsid not found
	    	   
	    if (oDevice.getPropertyNode().getChild('present').getValue()==false) {
	        sErrorMSG='Gert ' + dsid + ' aktuell nicht verfgbar';
	        lWarn.logln(sErrorMSG);
            //set the needed temp property to delete the device in the complete tep 
            Property.setProperty('temp/catalogeID', id);
            Property.setProperty('temp/dsid', dsid);
	        new Event('led-wizard.step',{detail:'complete',error:false}).raise();
	        new Event('led-wizard.answer',{detail:'complete',type:'step',error:false}).raise();
	        return;
	    }
	    
	
	    new Event('led-wizard.demo',{actions:'setValue',dsid:dsid,value:0}).raise();
	    
		lInfo.logln('prepareCurfe ' + dsid + ' mit ' +id);
		
		var oParameterList=prepareCurve(oDevice,id,false);
		lInfo.logln('habe liste ' + oParameterList);		
		
		if (oParameterList==false) {
		    lWarn.logln('Fehler!: Keine Parameterliste vorhanden');
			new Event('led-wizard.step',{detail:'complete',error:true}).raise();
			new Event('led-wizard.answer',{type:'step',detail:'complete',error:true}).raise();
			return;
		}

		Property.setProperty('temp/value', JSON.stringify(oParameterList));
		Property.setProperty('temp/step', 0);
		Property.setProperty('temp/catalogeID', id);
		Property.setProperty('temp/dsid', dsid);

		new Event('led-wizard.answer',{type:'step',detail:'prepare','count':oParameterList.length}).raise();
		new Event('led-wizard.step',{detail:'prepare','count':oParameterList.length}).raise();
	 } 
	 catch (e) {
		 lWarn.logln('Exception in led-wizard-prog.executeProgramm()'  + e);
		 new Event('led-wizard.step',{detail:'complete',error:true}).raise();
		 new Event('led-wizard.answer',{type:'step',detail:'complete',error:true}).raise();
	 }
}

/**
 * Removes the device with the given dsid from the property tree without reseting the dimming curve.
 * This function is used if a device was deleted from the dSS. 
 * @param dsid [in] dsid of the device to be removed
 */
function deleteDevice(dsid) {
    lInfo.logln('starte delete device fr ' + dsid + ' mit ' + id);
    //set the temp property for the complete step 
    Property.setProperty('temp/catalogeID', -1);
    Property.setProperty('temp/dsid', dsid);
    new Event('led-wizard.step',{detail:'complete',error:false}).raise();
    new Event('led-wizard.answer',{detail:'complete',type:'step',error:false}).raise();
}


if (raisedEvent.parameter.actions != null) {
    lInfo.logln("Event " +  raisedEvent.parameter.actions + " will be processed");
    Property.load();
	if (raisedEvent.parameter.actions == 'programmCurve') {		
    	executeProgramm(raisedEvent.parameter.dsid,raisedEvent.parameter.curve_id);        
    }
	if (raisedEvent.parameter.actions === 'deleteEntry') {
	    deleteDevice(raisedEvent.parameter.dsid);
	}
}

	
